SystemOrganization addCategory: #'Javascript-Core'!
SystemOrganization addCategory: #'Javascript-Core-Decorations'!
SystemOrganization addCategory: #'Javascript-Core-JSON'!

!WARenderer methodsFor: '*javascript-core' stamp: 'jf 7/19/2009 18:44'!
javascript
	^ (JSScript context: self context)
		rendererClass: self species;
		yourself! !

!WARenderer methodsFor: '*javascript-core' stamp: 'jf 7/19/2009 18:44'!
logger
	^ (JSLogger context: self context)
		rendererClass: self species;
		yourself! !

!WAUrl methodsFor: '*javascript-core' stamp: 'lr 10/13/2008 21:06'!
javascriptOn: aStream 
	aStream javascript: self printString! !

!Float methodsFor: '*javascript-core' stamp: 'lr 2/2/2010 22:26'!
jsonOn: aStream
	self javascriptOn: aStream! !

!GRPackage class methodsFor: '*javascript-core' stamp: 'lr 2/17/2010 15:11'!
javascriptCore
	^ self new
		name: 'Javascript-Core';
		description: 'Javascript integration in Seaside. Provides a basic functionality to generate Javascript from Smalltalk.';
		addDependency: 'Seaside-Core';
		addDependency: 'Seaside-Canvas';
		url: #seasideUrl;
		yourself! !

!Dictionary methodsFor: '*javascript-core' stamp: 'lr 2/12/2009 09:44'!
javascriptOn: aStream
	JSStream encodeDictionary: self on: aStream! !

!Dictionary methodsFor: '*javascript-core' stamp: 'jf 1/7/2010 10:55'!
jsonOn: aStream
	JSJsonStream encodeDictionary: self on: aStream! !

!Integer methodsFor: '*javascript-core' stamp: 'lr 2/2/2010 22:26'!
jsonOn: aStream
	self javascriptOn: aStream! !

!Date methodsFor: '*javascript-core' stamp: 'lr 3/13/2007 09:04'!
javascriptMonthIndex
	^ self monthIndex - 1! !

!Date methodsFor: '*javascript-core' stamp: 'lr 12/6/2009 19:48'!
javascriptOn: aStream
	aStream nextPutAll: 'new Date('.
	#( year javascriptMonthIndex dayOfMonth )
		do: [ :each | aStream javascript: (self perform: each) ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $)! !

!GRSmallDictionary methodsFor: '*javascript-core' stamp: 'lr 2/12/2009 09:44'!
javascriptOn: aStream
	JSStream encodeDictionary: self on: aStream! !

!GRSmallDictionary methodsFor: '*javascript-core' stamp: 'lr 2/2/2010 22:27'!
jsonOn: aStream
	JSJsonStream encodeDictionary: self on: aStream! !

!Collection methodsFor: '*javascript-core' stamp: 'lr 2/12/2009 09:43'!
javascriptOn: aStream
	JSStream encodeCollection: self on: aStream! !

!Collection methodsFor: '*javascript-core' stamp: 'lr 2/2/2010 22:27'!
jsonOn: aStream 
	JSJsonStream encodeCollection: self on: aStream! !

!Duration methodsFor: '*javascript-core' stamp: 'jf 2/6/2010 00:13'!
javascriptOn: aStream
	aStream javascript: self asMilliseconds! !

WAFileLibrary subclass: #JSJsonDeploymentLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-JSON'!

!JSJsonDeploymentLibrary methodsFor: 'uploads' stamp: 'lr 9/22/2009 10:31'!
json2Js
	^ 'if(!!this.JSON){this.JSON={};}(function(){function f(n){return n<10?"0"+n:n;}if(typeof Date.prototype.toJSON!!=="function"){Date.prototype.toJSON=function(key){return isFinite(this.valueOf())?this.getUTCFullYear()+"-"+f(this.getUTCMonth()+1)+"-"+f(this.getUTCDate())+"T"+f(this.getUTCHours())+":"+f(this.getUTCMinutes())+":"+f(this.getUTCSeconds())+"Z":null;};String.prototype.toJSON=Number.prototype.toJSON=Boolean.prototype.toJSON=function(key){return this.valueOf();};}var cx=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,escapable=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,gap,indent,meta={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",''"'':''\\"'',"\\":"\\\\"},rep;function quote(string){escapable.lastIndex=0;return escapable.test(string)?''"''+string.replace(escapable,function(a){var c=meta[a];return typeof c==="string"?c:"\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4);})+''"'':''"''+string+''"'';}function str(key,holder){var i,k,v,length,mind=gap,partial,value=holder[key];if(value&&typeof value==="object"&&typeof value.toJSON==="function"){value=value.toJSON(key);}if(typeof rep==="function"){value=rep.call(holder,key,value);}switch(typeof value){case"string":return quote(value);case"number":return isFinite(value)?String(value):"null";case"boolean":case"null":return String(value);case"object":if(!!value){return"null";}gap+=indent;partial=[];if(Object.prototype.toString.apply(value)==="[object Array]"){length=value.length;for(i=0;i<length;i+=1){partial[i]=str(i,value)||"null";}v=partial.length===0?"[]":gap?"[\n"+gap+partial.join(",\n"+gap)+"\n"+mind+"]":"["+partial.join(",")+"]";gap=mind;return v;}if(rep&&typeof rep==="object"){length=rep.length;for(i=0;i<length;i+=1){k=rep[i];if(typeof k==="string"){v=str(k,value);if(v){partial.push(quote(k)+(gap?": ":":")+v);}}}}else{for(k in value){if(Object.hasOwnProperty.call(value,k)){v=str(k,value);if(v){partial.push(quote(k)+(gap?": ":":")+v);}}}}v=partial.length===0?"{}":gap?"{\n"+gap+partial.join(",\n"+gap)+"\n"+mind+"}":"{"+partial.join(",")+"}";gap=mind;return v;}}if(typeof JSON.stringify!!=="function"){JSON.stringify=function(value,replacer,space){var i;gap="";indent="";if(typeof space==="number"){for(i=0;i<space;i+=1){indent+=" ";}}else{if(typeof space==="string"){indent=space;}}rep=replacer;if(replacer&&typeof replacer!!=="function"&&(typeof replacer!!=="object"||typeof replacer.length!!=="number")){throw new Error("JSON.stringify");}return str("",{"":value});};}if(typeof JSON.parse!!=="function"){JSON.parse=function(text,reviver){var j;function walk(holder,key){var k,v,value=holder[key];if(value&&typeof value==="object"){for(k in value){if(Object.hasOwnProperty.call(value,k)){v=walk(value,k);if(v!!==undefined){value[k]=v;}else{delete value[k];}}}}return reviver.call(holder,key,value);}cx.lastIndex=0;if(cx.test(text)){text=text.replace(cx,function(a){return"\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4);});}if(/^[\],:{}\s]*$/.test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,"@").replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,"]").replace(/(?:^|:|,)(?:\s*\[)+/g,""))){j=eval("("+text+")");return typeof reviver==="function"?walk({"":j},""):j;}throw new SyntaxError("JSON.parse");};}}());'! !

!JSJsonDeploymentLibrary methodsFor: 'accessing' stamp: 'lr 9/22/2009 10:31'!
selectorsToInclude
	^ #(json2Js)! !

WAFileLibrary subclass: #JSJsonDevelopmentLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-JSON'!

!JSJsonDevelopmentLibrary methodsFor: 'uploads' stamp: 'lr 9/22/2009 10:29'!
json2Js
	^ '/*
    http://www.JSON.org/json2.js
    2009-08-17

    Public Domain.

    NO WARRANTY EXPRESSED OR IMPLIED. USE AT YOUR OWN RISK.

    See http://www.JSON.org/js.html

    This file creates a global JSON object containing two methods: stringify
    and parse.

        JSON.stringify(value, replacer, space)
            value       any JavaScript value, usually an object or array.

            replacer    an optional parameter that determines how object
                        values are stringified for objects. It can be a
                        function or an array of strings.

            space       an optional parameter that specifies the indentation
                        of nested structures. If it is omitted, the text will
                        be packed without extra whitespace. If it is a number,
                        it will specify the number of spaces to indent at each
                        level. If it is a string (such as ''\t'' or ''&nbsp;''),
                        it contains the characters used to indent at each level.

            This method produces a JSON text from a JavaScript value.

            When an object value is found, if the object contains a toJSON
            method, its toJSON method will be called and the result will be
            stringified. A toJSON method does not serialize: it returns the
            value represented by the name/value pair that should be serialized,
            or undefined if nothing should be serialized. The toJSON method
            will be passed the key associated with the value, and this will be
            bound to the value

            For example, this would serialize Dates as ISO strings.

                Date.prototype.toJSON = function (key) {
                    function f(n) {
                        // Format integers to have at least two digits.
                        return n < 10 ? ''0'' + n : n;
                    }

                    return this.getUTCFullYear()   + ''-'' +
                         f(this.getUTCMonth() + 1) + ''-'' +
                         f(this.getUTCDate())      + ''T'' +
                         f(this.getUTCHours())     + '':'' +
                         f(this.getUTCMinutes())   + '':'' +
                         f(this.getUTCSeconds())   + ''Z'';
                };

            You can provide an optional replacer method. It will be passed the
            key and value of each member, with this bound to the containing
            object. The value that is returned from your method will be
            serialized. If your method returns undefined, then the member will
            be excluded from the serialization.

            If the replacer parameter is an array of strings, then it will be
            used to select the members to be serialized. It filters the results
            such that only members with keys listed in the replacer array are
            stringified.

            Values that do not have JSON representations, such as undefined or
            functions, will not be serialized. Such values in objects will be
            dropped; in arrays they will be replaced with null. You can use
            a replacer function to replace those with JSON values.
            JSON.stringify(undefined) returns undefined.

            The optional space parameter produces a stringification of the
            value that is filled with line breaks and indentation to make it
            easier to read.

            If the space parameter is a non-empty string, then that string will
            be used for indentation. If the space parameter is a number, then
            the indentation will be that many spaces.

            Example:

            text = JSON.stringify([''e'', {pluribus: ''unum''}]);
            // text is ''["e",{"pluribus":"unum"}]''


            text = JSON.stringify([''e'', {pluribus: ''unum''}], null, ''\t'');
            // text is ''[\n\t"e",\n\t{\n\t\t"pluribus": "unum"\n\t}\n]''

            text = JSON.stringify([new Date()], function (key, value) {
                return this[key] instanceof Date ?
                    ''Date('' + this[key] + '')'' : value;
            });
            // text is ''["Date(---current time---)"]''


        JSON.parse(text, reviver)
            This method parses a JSON text to produce an object or array.
            It can throw a SyntaxError exception.

            The optional reviver parameter is a function that can filter and
            transform the results. It receives each of the keys and values,
            and its return value is used instead of the original value.
            If it returns what it received, then the structure is not modified.
            If it returns undefined then the member is deleted.

            Example:

            // Parse the text. Values that look like ISO date strings will
            // be converted to Date objects.

            myData = JSON.parse(text, function (key, value) {
                var a;
                if (typeof value === ''string'') {
                    a =
/^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2}(?:\.\d*)?)Z$/.exec(value);
                    if (a) {
                        return new Date(Date.UTC(+a[1], +a[2] - 1, +a[3], +a[4],
                            +a[5], +a[6]));
                    }
                }
                return value;
            });

            myData = JSON.parse(''["Date(09/09/2001)"]'', function (key, value) {
                var d;
                if (typeof value === ''string'' &&
                        value.slice(0, 5) === ''Date('' &&
                        value.slice(-1) === '')'') {
                    d = new Date(value.slice(5, -1));
                    if (d) {
                        return d;
                    }
                }
                return value;
            });


    This is a reference implementation. You are free to copy, modify, or
    redistribute.

    This code should be minified before deployment.
    See http://javascript.crockford.com/jsmin.html

    USE YOUR OWN COPY. IT IS EXTREMELY UNWISE TO LOAD CODE FROM SERVERS YOU DO
    NOT CONTROL.
*/

/*jslint evil: true */

/*members "", "\b", "\t", "\n", "\f", "\r", "\"", JSON, "\\", apply,
    call, charCodeAt, getUTCDate, getUTCFullYear, getUTCHours,
    getUTCMinutes, getUTCMonth, getUTCSeconds, hasOwnProperty, join,
    lastIndex, length, parse, prototype, push, replace, slice, stringify,
    test, toJSON, toString, valueOf
*/

"use strict";

// Create a JSON object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.

if (!!this.JSON) {
    this.JSON = {};
}

(function () {

    function f(n) {
        // Format integers to have at least two digits.
        return n < 10 ? ''0'' + n : n;
    }

    if (typeof Date.prototype.toJSON !!== ''function'') {

        Date.prototype.toJSON = function (key) {

            return isFinite(this.valueOf()) ?
                   this.getUTCFullYear()   + ''-'' +
                 f(this.getUTCMonth() + 1) + ''-'' +
                 f(this.getUTCDate())      + ''T'' +
                 f(this.getUTCHours())     + '':'' +
                 f(this.getUTCMinutes())   + '':'' +
                 f(this.getUTCSeconds())   + ''Z'' : null;
        };

        String.prototype.toJSON =
        Number.prototype.toJSON =
        Boolean.prototype.toJSON = function (key) {
            return this.valueOf();
        };
    }

    var cx = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        escapable = /[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        gap,
        indent,
        meta = {    // table of character substitutions
            ''\b'': ''\\b'',
            ''\t'': ''\\t'',
            ''\n'': ''\\n'',
            ''\f'': ''\\f'',
            ''\r'': ''\\r'',
            ''"'' : ''\\"'',
            ''\\'': ''\\\\''
        },
        rep;


    function quote(string) {

// If the string contains no control characters, no quote characters, and no
// backslash characters, then we can safely slap some quotes around it.
// Otherwise we must also replace the offending characters with safe escape
// sequences.

        escapable.lastIndex = 0;
        return escapable.test(string) ?
            ''"'' + string.replace(escapable, function (a) {
                var c = meta[a];
                return typeof c === ''string'' ? c :
                    ''\\u'' + (''0000'' + a.charCodeAt(0).toString(16)).slice(-4);
            }) + ''"'' :
            ''"'' + string + ''"'';
    }


    function str(key, holder) {

// Produce a string from holder[key].

        var i,          // The loop counter.
            k,          // The member key.
            v,          // The member value.
            length,
            mind = gap,
            partial,
            value = holder[key];

// If the value has a toJSON method, call it to obtain a replacement value.

        if (value && typeof value === ''object'' &&
                typeof value.toJSON === ''function'') {
            value = value.toJSON(key);
        }

// If we were called with a replacer function, then call the replacer to
// obtain a replacement value.

        if (typeof rep === ''function'') {
            value = rep.call(holder, key, value);
        }

// What happens next depends on the value''s type.

        switch (typeof value) {
        case ''string'':
            return quote(value);

        case ''number'':

// JSON numbers must be finite. Encode non-finite numbers as null.

            return isFinite(value) ? String(value) : ''null'';

        case ''boolean'':
        case ''null'':

// If the value is a boolean or null, convert it to a string. Note:
// typeof null does not produce ''null''. The case is included here in
// the remote chance that this gets fixed someday.

            return String(value);

// If the type is ''object'', we might be dealing with an object or an array or
// null.

        case ''object'':

// Due to a specification blunder in ECMAScript, typeof null is ''object'',
// so watch out for that case.

            if (!!value) {
                return ''null'';
            }

// Make an array to hold the partial results of stringifying this object value.

            gap += indent;
            partial = [];

// Is the value an array?

            if (Object.prototype.toString.apply(value) === ''[object Array]'') {

// The value is an array. Stringify every element. Use null as a placeholder
// for non-JSON values.

                length = value.length;
                for (i = 0; i < length; i += 1) {
                    partial[i] = str(i, value) || ''null'';
                }

// Join all of the elements together, separated with commas, and wrap them in
// brackets.

                v = partial.length === 0 ? ''[]'' :
                    gap ? ''[\n'' + gap +
                            partial.join('',\n'' + gap) + ''\n'' +
                                mind + '']'' :
                          ''['' + partial.join('','') + '']'';
                gap = mind;
                return v;
            }

// If the replacer is an array, use it to select the members to be stringified.

            if (rep && typeof rep === ''object'') {
                length = rep.length;
                for (i = 0; i < length; i += 1) {
                    k = rep[i];
                    if (typeof k === ''string'') {
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? '': '' : '':'') + v);
                        }
                    }
                }
            } else {

// Otherwise, iterate through all of the keys in the object.

                for (k in value) {
                    if (Object.hasOwnProperty.call(value, k)) {
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? '': '' : '':'') + v);
                        }
                    }
                }
            }

// Join all of the member texts together, separated with commas,
// and wrap them in braces.

            v = partial.length === 0 ? ''{}'' :
                gap ? ''{\n'' + gap + partial.join('',\n'' + gap) + ''\n'' +
                        mind + ''}'' : ''{'' + partial.join('','') + ''}'';
            gap = mind;
            return v;
        }
    }

// If the JSON object does not yet have a stringify method, give it one.

    if (typeof JSON.stringify !!== ''function'') {
        JSON.stringify = function (value, replacer, space) {

// The stringify method takes a value and an optional replacer, and an optional
// space parameter, and returns a JSON text. The replacer can be a function
// that can replace values, or an array of strings that will select the keys.
// A default replacer method can be provided. Use of the space parameter can
// produce text that is more easily readable.

            var i;
            gap = '''';
            indent = '''';

// If the space parameter is a number, make an indent string containing that
// many spaces.

            if (typeof space === ''number'') {
                for (i = 0; i < space; i += 1) {
                    indent += '' '';
                }

// If the space parameter is a string, it will be used as the indent string.

            } else if (typeof space === ''string'') {
                indent = space;
            }

// If there is a replacer, it must be a function or an array.
// Otherwise, throw an error.

            rep = replacer;
            if (replacer && typeof replacer !!== ''function'' &&
                    (typeof replacer !!== ''object'' ||
                     typeof replacer.length !!== ''number'')) {
                throw new Error(''JSON.stringify'');
            }

// Make a fake root object containing our value under the key of ''''.
// Return the result of stringifying the value.

            return str('''', {'''': value});
        };
    }


// If the JSON object does not yet have a parse method, give it one.

    if (typeof JSON.parse !!== ''function'') {
        JSON.parse = function (text, reviver) {

// The parse method takes a text and an optional reviver function, and returns
// a JavaScript value if the text is a valid JSON text.

            var j;

            function walk(holder, key) {

// The walk method is used to recursively walk the resulting structure so
// that modifications can be made.

                var k, v, value = holder[key];
                if (value && typeof value === ''object'') {
                    for (k in value) {
                        if (Object.hasOwnProperty.call(value, k)) {
                            v = walk(value, k);
                            if (v !!== undefined) {
                                value[k] = v;
                            } else {
                                delete value[k];
                            }
                        }
                    }
                }
                return reviver.call(holder, key, value);
            }


// Parsing happens in four stages. In the first stage, we replace certain
// Unicode characters with escape sequences. JavaScript handles many characters
// incorrectly, either silently deleting them, or treating them as line endings.

            cx.lastIndex = 0;
            if (cx.test(text)) {
                text = text.replace(cx, function (a) {
                    return ''\\u'' +
                        (''0000'' + a.charCodeAt(0).toString(16)).slice(-4);
                });
            }

// In the second stage, we run the text against regular expressions that look
// for non-JSON patterns. We are especially concerned with ''()'' and ''new''
// because they can cause invocation, and ''='' because it can cause mutation.
// But just to be safe, we want to reject all unexpected forms.

// We split the second stage into 4 regexp operations in order to work around
// crippling inefficiencies in IE''s and Safari''s regexp engines. First we
// replace the JSON backslash pairs with ''@'' (a non-JSON character). Second, we
// replace all simple value tokens with '']'' characters. Third, we delete all
// open brackets that follow a colon or comma or that begin the text. Finally,
// we look to see that the remaining characters are only whitespace or '']'' or
// '','' or '':'' or ''{'' or ''}''. If that is so, then the text is safe for eval.

            if (/^[\],:{}\s]*$/.
test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g, ''@'').
replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, '']'').
replace(/(?:^|:|,)(?:\s*\[)+/g, ''''))) {

// In the third stage we use the eval function to compile the text into a
// JavaScript structure. The ''{'' operator is subject to a syntactic ambiguity
// in JavaScript: it can begin a block or an object literal. We wrap the text
// in parens to eliminate the ambiguity.

                j = eval(''('' + text + '')'');

// In the optional fourth stage, we recursively walk the new structure, passing
// each name/value pair to a reviver function for possible transformation.

                return typeof reviver === ''function'' ?
                    walk({'''': j}, '''') : j;
            }

// If the text is not JSON parseable, then a SyntaxError is thrown.

            throw new SyntaxError(''JSON.parse'');
        };
    }
}());'! !

!JSJsonDevelopmentLibrary methodsFor: 'accessing' stamp: 'lr 9/22/2009 10:31'!
selectorsToInclude
	^ #(json2Js)! !

!UndefinedObject methodsFor: '*javascript-core' stamp: 'lr 4/11/2006 19:44'!
javascriptOn: aStream
	aStream nextPutAll: 'null'! !

!UndefinedObject methodsFor: '*javascript-core' stamp: 'lr 2/2/2010 22:26'!
jsonOn: aStream
	self javascriptOn: aStream! !

!WATagBrush methodsFor: '*javascript-core' stamp: 'lr 1/23/2009 07:58'!
passenger: anObject
	"Assign a passenger object to the receiver. This is used to keep a mapping between DOM elements and Smalltalk objects. Note, that to we are required to assign a numeric id to the reciever in order to keep the mapping between DOM element and Smalltalk object."

	canvas callbacks registerPassenger: anObject named: self ensureId! !

!WATagBrush methodsFor: '*javascript-core' stamp: 'lr 12/24/2009 10:31'!
script: anObject
	"Attach a JavaScript object to the receiver. The argument automatically knows the ID of the DOM element it should operate on and will be evaluated when the page complete loading."

	(anObject isNil) 
		ifTrue: [ ^ self ].
	(anObject respondsTo: #id:)
		ifTrue: [ anObject id: self ensureId ].
	canvas document addLoadScript: anObject! !

!Character methodsFor: '*javascript-core' stamp: 'lr 7/12/2006 12:09'!
javascriptOn: aStream
	(String with: self) javascriptOn: aStream! !

!Character methodsFor: '*javascript-core' stamp: 'lr 2/2/2010 22:42'!
jsonOn: aStream
	self javascriptOn: aStream! !

WAError subclass: #JSJsonSyntaxError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-JSON'!

!JSJsonSyntaxError commentStamp: 'pmm 12/15/2008 19:45' prior: 0!
A JSJsonSyntaxError signals invalid JSON input.
!

!Object methodsFor: '*javascript-core' stamp: 'lr 1/4/2007 17:20'!
asFunction
	^ self asFunction: #()! !

!Object methodsFor: '*javascript-core' stamp: 'lr 10/14/2008 00:37'!
asFunction: aCollection
	^ JSFunction new add: self; arguments: aCollection! !

!Object methodsFor: '*javascript-core' stamp: 'lr 4/11/2006 19:49'!
asJavascript
	^ String streamContents: [ :stream | self javascriptOn: stream ]! !

!Object methodsFor: '*javascript-core' stamp: 'jf 1/7/2010 10:35'!
asJson
	^ String streamContents: [ :stream | self jsonOn: stream ]! !

!Object methodsFor: '*javascript-core' stamp: 'lr 12/4/2008 22:30'!
isJavascript
	^ false! !

!Object methodsFor: '*javascript-core' stamp: 'lr 4/20/2006 21:10'!
javascriptOn: aStream
	self printOn: aStream! !

!Object methodsFor: '*javascript-core' stamp: 'lr 2/6/2010 12:39'!
jsonOn: aStream
	self error: 'Override #jsonOn: to make the receiver serializeable as JSON'! !

!String methodsFor: '*javascript-core' stamp: 'lr 10/14/2008 00:37'!
asFunction: aCollection
	^ (JSStream on: self) asFunction: aCollection! !

!String methodsFor: '*javascript-core' stamp: 'lr 2/12/2009 09:45'!
javascriptOn: aStream
	JSStream encodeString: self on: aStream! !

!String methodsFor: '*javascript-core' stamp: 'lr 2/2/2010 22:26'!
jsonOn: aStream
	self javascriptOn: aStream! !

!WACallbackRegistry methodsFor: '*javascript-core' stamp: 'lr 10/21/2008 16:39'!
passengerAt: aString
	^ self passengerAt: aString ifAbsent: [ nil ]! !

!WACallbackRegistry methodsFor: '*javascript-core' stamp: 'lr 12/28/2008 16:33'!
passengerAt: aString ifAbsent: aBlock
	| passenger |
	passenger := callbacks at: aString ifAbsent: [ ^ aBlock value ].
	passenger isPassenger ifFalse: [ ^ aBlock value ].
	^ passenger object! !

!WACallbackRegistry methodsFor: '*javascript-core' stamp: 'jf 9/30/2009 01:02'!
registerAjaxCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerAjaxCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (JSAjaxCallback on: aBlock)! !

!WACallbackRegistry methodsFor: '*javascript-core' stamp: 'lr 1/23/2009 08:01'!
registerPassenger: anObject named: aString
	| callback |
	callback := JSPassenger new.
	callback setKey: aString callbacks: callbacks; setObject: anObject.
	callbacks at: (callback convertKey: aString) put: callback.
	^ aString! !

!DateAndTime methodsFor: '*javascript-core' stamp: 'lr 3/13/2007 09:05'!
javascriptMonthIndex
	^ self monthIndex - 1! !

!DateAndTime methodsFor: '*javascript-core' stamp: 'lr 12/6/2009 19:48'!
javascriptOn: aStream
	aStream nextPutAll: 'new Date('.
	#( year javascriptMonthIndex dayOfMonth hour minute second )
		do: [ :each | aStream javascript: (self perform: each) ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $)! !

WAObject subclass: #JSDecoration
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSDecoration commentStamp: 'lr 4/28/2008 09:47' prior: 0!
I decorate JavaScript objects.!

JSDecoration subclass: #JSApply
	instanceVariableNames: 'arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSApply commentStamp: 'lr 4/28/2008 09:47' prior: 0!
I apply a JavaScript function and provide arguments.!

!JSApply methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:49'!
arguments
	^ arguments! !

!JSApply methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:49'!
arguments: aCollection
	arguments := aCollection! !

!JSApply methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	super javascriptContentOn: aStream.
	JSStream encodeArguments: self arguments on: aStream! !

JSDecoration subclass: #JSAssignment
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSAssignment commentStamp: 'lr 4/28/2008 09:48' prior: 0!
I represent an assignment ot the decorated object.!

!JSAssignment methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	super javascriptContentOn: aStream.
	aStream
		nextPutAll: '=';
		javascript: self object! !

!JSAssignment methodsFor: 'accessing' stamp: 'lr 7/4/2007 07:43'!
object
	^ object! !

!JSAssignment methodsFor: 'accessing' stamp: 'lr 7/4/2007 07:44'!
object: anObject
	object := anObject! !

JSDecoration subclass: #JSCall
	instanceVariableNames: 'name arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSCall commentStamp: 'pmm 2/18/2011 22:52' prior: 0!
I represent a function call or method invocation to the decorated object.!

!JSCall methodsFor: 'accessing' stamp: 'lr 4/7/2009 16:48'!
arguments
	^ arguments! !

!JSCall methodsFor: 'accessing' stamp: 'lr 4/7/2009 16:48'!
arguments: anArray 
	arguments := anArray! !

!JSCall methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	super javascriptContentOn: aStream.
	(self name isNil or: [ self name isEmpty ]) ifFalse:
			[ aStream
				nextPut: $.;
				nextPutAll: self name ].
	JSStream encodeArguments: self arguments on: aStream! !

!JSCall methodsFor: 'accessing' stamp: 'lr 4/7/2009 16:48'!
name
	^ name! !

!JSCall methodsFor: 'accessing' stamp: 'lr 4/7/2009 16:48'!
name: aString 
	name := aString! !

JSDecoration subclass: #JSCreate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSCreate commentStamp: 'lr 4/28/2008 09:48' prior: 0!
I instantiate the decorated object.!

!JSCreate methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	aStream nextPutAll: 'new '.
	super javascriptContentOn: aStream! !

!JSDecoration methodsFor: 'testing' stamp: 'lr 12/4/2008 22:31'!
isJavascript
	^ true! !

!JSDecoration methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	self owner javascriptContentOn: aStream! !

!JSDecoration methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:09'!
owner
	^ owner! !

!JSDecoration methodsFor: 'accessing' stamp: 'jf 7/19/2009 15:00'!
renderContext
	^ owner renderContext! !

!JSDecoration methodsFor: 'initialization' stamp: 'lr 11/17/2008 20:15'!
setOwner: anObject
	owner := anObject! !

JSDecoration subclass: #JSIfThenElse
	instanceVariableNames: 'trueStatement falseStatement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSIfThenElse commentStamp: 'lr 4/28/2008 09:50' prior: 0!
I execute different code snippets depending if the receiver is true (defined) or false (null).!

!JSIfThenElse methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:16'!
falseStatement
	^ falseStatement! !

!JSIfThenElse methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:16'!
falseStatement: anObject
	falseStatement := anObject! !

!JSIfThenElse methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	aStream nextPut: $(.
	super javascriptContentOn: aStream.
	aStream nextPut: $?.
	aStream javascript: self trueStatement.
	aStream nextPut: $:.
	aStream javascript: self falseStatement.
	aStream nextPut: $)! !

!JSIfThenElse methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:16'!
trueStatement
	^ trueStatement! !

!JSIfThenElse methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:16'!
trueStatement: anObject
	trueStatement := anObject! !

JSDecoration subclass: #JSMember
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

JSMember subclass: #JSAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSAccess commentStamp: 'lr 4/28/2008 09:51' prior: 0!
I access a member of the decorated object.!

!JSAccess methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	super javascriptContentOn: aStream.
	aStream
		nextPut: $.;
		nextPutAll: self name! !

JSMember subclass: #JSAlias
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSAlias commentStamp: 'lr 4/28/2008 09:51' prior: 0!
I alias the decorated object with a name.!

!JSAlias methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	aStream nextPutAll: self name! !

JSMember subclass: #JSAssign
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSAssign commentStamp: 'lr 4/28/2008 09:51' prior: 0!
I assign the decorated object to a global variable.!

!JSAssign methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	aStream
		nextPutAll: self name;
		nextPut: $=.
	super javascriptContentOn: aStream! !

JSAssign subclass: #JSAssignLocal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSAssignLocal commentStamp: 'lr 4/28/2008 09:52' prior: 0!
I assign the decorated object to a local variable.!

!JSAssignLocal methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	aStream nextPutAll: 'var '.
	super javascriptContentOn: aStream! !

!JSMember class methodsFor: 'instance creation' stamp: 'lr 10/13/2008 21:42'!
named: anObject
	^ self new name: anObject! !

!JSMember methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:46'!
name
	^ name! !

!JSMember methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:46'!
name: aString
	name := aString! !

JSMember subclass: #JSProperty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSProperty commentStamp: 'pmm 2/18/2011 22:52' prior: 0!
I access a property of the decorated object.!

!JSProperty methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	super javascriptContentOn: aStream.
	aStream
		nextPut: $[;
		javascript: self name;
		nextPut: $]! !

JSDecoration subclass: #JSNegation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSNegation commentStamp: 'lr 4/28/2008 09:52' prior: 0!
I negate the decorated object and yield a boolean value.!

!JSNegation methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	aStream nextPut: $!!.
	super javascriptContentOn: aStream! !

JSDecoration subclass: #JSStatement
	instanceVariableNames: 'statement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

JSStatement subclass: #JSBinary
	instanceVariableNames: 'operator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSBinary commentStamp: 'lr 4/28/2008 09:54' prior: 0!
I join the decorated object with a binary operator.!

!JSBinary methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	super javascriptContentOn: aStream.
	aStream
		nextPutAll: self operator;
		javascript: self statement! !

!JSBinary methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:22'!
operator
	^ operator! !

!JSBinary methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:22'!
operator: aString
	operator := aString! !

JSStatement subclass: #JSConcatenation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSConcatenation commentStamp: 'lr 12/31/2009 23:54' prior: 0!
I represent a sequence (or concatenation) of a decorated object and another object.!

!JSConcatenation methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	super javascriptContentOn: aStream.
	aStream
		nextPut: $;;
		javascript: self statement! !

JSStatement subclass: #JSCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSCondition commentStamp: 'lr 4/28/2008 09:53' prior: 0!
I wrap the decorated object into a conditional statement.!

!JSCondition methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	aStream
		nextPutAll: 'if(';
		javascript: self statement;
		nextPutAll: '){'.
	super javascriptContentOn: aStream.
	aStream nextPut: $}! !

!JSStatement class methodsFor: 'instance creation' stamp: 'lr 5/9/2006 20:19'!
on: anObject
	^ self new statement: anObject! !

!JSStatement methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:14'!
statement
	^ statement! !

!JSStatement methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:14'!
statement: anObject
	statement := anObject! !

JSDecoration subclass: #JSTimed
	instanceVariableNames: 'duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

JSTimed subclass: #JSInterval
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSInterval commentStamp: 'lr 10/13/2008 21:46' prior: 0!
I periodically execute the decorated object.!

!JSInterval methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	aStream nextPutAll: 'setInterval(function(){'.
	super javascriptContentOn: aStream.
	aStream
		nextPutAll: '},';
		javascript: self duration;
		nextPut: $)! !

!JSTimed class methodsFor: 'instance creation' stamp: 'lr 10/13/2008 21:45'!
duration: aDuration
	^ self new duration: aDuration! !

!JSTimed methodsFor: 'accessing' stamp: 'lr 10/13/2008 21:39'!
duration
	^ duration! !

!JSTimed methodsFor: 'accessing' stamp: 'lr 10/13/2008 21:39'!
duration: aDuration
	duration := aDuration! !

JSTimed subclass: #JSTimeout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSTimeout commentStamp: 'lr 4/28/2008 09:54' prior: 0!
I evaluate the decorated object after a timeout.!

!JSTimeout methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	aStream nextPutAll: 'setTimeout(function(){'.
	super javascriptContentOn: aStream.
	aStream
		nextPutAll: '},';
		javascript: self duration;
		nextPut: $)! !

WAObject subclass: #JSJsonParser
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-JSON'!

!JSJsonParser commentStamp: 'lr 12/31/2009 23:56' prior: 0!
I am a parser for JSON. It is a bit more forgiving than the standard and allows any kind of top level element except numbers, not just {} and []. See http://www.json.org/ for details.

I can be subclasses to create more sophisticated objects than just Arrays and Dictionaries. To do that, override the one or more methods in the creating protocol.!

!JSJsonParser class methodsFor: 'instance creation' stamp: 'lr 6/25/2009 15:58'!
new
	self error: 'Instantiate the parser with a stream.'! !

!JSJsonParser class methodsFor: 'instance creation' stamp: 'lr 6/25/2009 15:57'!
on: aStream
	^ self basicNew initializeOn: aStream! !

!JSJsonParser class methodsFor: 'accessing' stamp: 'lr 6/25/2009 15:55'!
parse: aString
	^ self parseStream: aString readStream! !

!JSJsonParser class methodsFor: 'accessing' stamp: 'lr 6/25/2009 15:57'!
parseStream: aStream
	^ (self on: aStream) parse! !

!JSJsonParser methodsFor: 'adding' stamp: 'lr 6/25/2009 20:06'!
addProperty: anAssociation to: anObject
	"Add the property anAssociation described with key and value to anObject. Subclasses might want to refine this implementation."
	
	^ anObject 
		add: anAssociation;
		yourself! !

!JSJsonParser methodsFor: 'adding' stamp: 'lr 9/22/2009 10:33'!
addValue: anObject to: aCollection
	"Add anObject to aCollection. Subclasses might want to refine this implementation."

	^ aCollection copyWith: anObject! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 6/25/2009 20:06'!
createArray
	"Create an empty collection. Subclasses might want to refine this implementation."

	^ Array new! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:54'!
createFalse
	"Create the false literal. Subclasses might want to refine this implementation."
	
	^ false! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:54'!
createNull
	"Create the null literal. Subclasses might want to refine this implementation."

	^ nil! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:54'!
createNumber: aString
	"Create a number literal. Subclasses might want to refine this implementation."

	^ aString asNumber! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 6/25/2009 16:53'!
createObject
	"Create an empty object. Subclasses might want to refine this implementation."
	
	^ Dictionary new! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:55'!
createProperty: aKey with: aValue
	"Create an empty attribute value pair. Subclasses might want to refine this implementation."
	
	^ aKey -> aValue! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:54'!
createString: aString
	"Create a string literal. Subclasses might want to refine this implementation."

	^ aString! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:55'!
createTrue
	"Create the true literal. Subclasses might want to refine this implementation."

	^ true! !

!JSJsonParser methodsFor: 'private' stamp: 'lr 6/25/2009 16:09'!
error: aString
	"Raise a parse error labelled aString."

	^ JSJsonSyntaxError signal: aString! !

!JSJsonParser methodsFor: 'private' stamp: 'lr 6/29/2009 14:28'!
expect: aString
	"Expects aString and consume input, throw an error otherwise."

	^ (self match: aString) ifFalse: [ self error: aString , ' expected' ]! !

!JSJsonParser methodsFor: 'initialization' stamp: 'lr 1/25/2010 23:33'!
initializeOn: aStream
	self initialize.
	stream := aStream! !

!JSJsonParser methodsFor: 'private' stamp: 'jok 7/16/2009 15:29'!
match: aString
	"Tries to match aString, consume input and answer true if successful."
	
	| position |
	position := stream position.
	aString do: [ :each |
		(stream atEnd or: [ stream next ~= each ]) ifTrue: [ 
			stream position: position.
			^ false ] ].
	self whitespace.
	^ true! !

!JSJsonParser methodsFor: 'parsing' stamp: 'lr 6/25/2009 23:00'!
parse
	| result |
	result := self whitespace; parseValue.
	stream atEnd
		ifFalse: [ self error: 'end of input expected' ].
	^ result! !

!JSJsonParser methodsFor: 'parsing' stamp: 'lr 9/8/2009 19:45'!
parseArray
	| result |
	self expect: '['.
	result := self createArray.
	(self match: ']')
		ifTrue: [ ^ result ].
	[ stream atEnd ] whileFalse: [
		result := self
			addValue: self parseValue
			to: result.
		(self match: ']') 
			ifTrue: [ ^ result ].
		self expect: ',' ].
	self error: 'end of array expected'! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 6/29/2009 14:39'!
parseCharacter
	| char |
	(char := stream next) = $\ 
		ifFalse: [ ^ char ].
	(char := stream next) = $" 
		ifTrue: [ ^ char ].
	char = $\
		ifTrue: [ ^ char ].
	char = $/
		ifTrue: [ ^ char ].
	char = $b
		ifTrue: [ ^ Character backspace ].
	char = $f
		ifTrue: [ ^ Character newPage ].
	char = $n
		ifTrue: [ ^ Character lf ].
	char = $r
		ifTrue: [ ^ Character cr ].
	char = $t
		ifTrue: [ ^ Character tab ].
	char = $u
		ifTrue: [ ^ self parseCharacterHex ].
	self error: 'invalid escape character \' , (String with: char)! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 7/16/2009 08:52'!
parseCharacterHex
	| value |
	value := self parseCharacterHexDigit.
	3 timesRepeat: [ value := (value << 4) + self parseCharacterHexDigit ].
	^ Character codePoint: value! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 7/26/2011 08:17'!
parseCharacterHexDigit
	| digit |
	stream atEnd ifFalse: [ 
		digit := stream next greaseInteger.
		(digit between: "$0" 48 and: "$9" 57)
			ifTrue: [ ^ digit - 48 ].
		(digit between: "$A" 65 and: "$F" 70)
			ifTrue: [ ^ digit - 55 ].
		(digit between: "$a" 97 and: "$f" 102)
			ifTrue: [ ^ digit - 87 ] ].
	self error: 'hex-digit expected'! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 6/25/2009 23:17'!
parseNumber
	| negated number |
	negated := stream peek = $-.
	negated ifTrue: [ stream next ].
	number := self parseNumberInteger.
	(stream peek = $.) ifTrue: [
		stream next. 
		number := number + self parseNumberFraction ].
	(stream peek = $e or: [ stream peek = $E ]) ifTrue: [
		stream next.
		number := number * self parseNumberExponent ].
	negated ifTrue: [ number := number negated ].
	^ self whitespace; createNumber: number! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 7/26/2011 08:18'!
parseNumberExponent
	| number negated |
	number := 0.
	negated := stream peek = $-.
	(negated or: [ stream peek = $+ ]) ifTrue: [ stream next ].
	[ stream atEnd not and: [ stream peek isDigit ] ]
		whileTrue: [ number := 10 * number + (stream next greaseInteger - 48) ].
	negated ifTrue: [ number := number negated ].
	^ 10 raisedTo: number! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 7/26/2011 08:18'!
parseNumberFraction
	| number power |
	number := 0.
	power := 1.0.
	[ stream atEnd not and: [ stream peek isDigit ] ] whileTrue: [
		number := 10 * number + (stream next greaseInteger - 48).
		power := power * 10.0 ].
	^ number / power! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 7/26/2011 08:18'!
parseNumberInteger
	| number |
	number := 0.
	[ stream atEnd not and: [ stream peek isDigit ] ]
		whileTrue: [ number := 10 * number + (stream next greaseInteger - 48) ].
	^ number! !

!JSJsonParser methodsFor: 'parsing' stamp: 'lr 9/8/2009 19:44'!
parseObject
	| result |
	self expect: '{'.
	result := self createObject.
	(self match: '}')
		ifTrue: [ ^ result ].
	[ stream atEnd ] whileFalse: [
		result := self
			addProperty: self parseProperty
			to: result.
		(self match: '}')
			ifTrue: [ ^ result ].
		self expect: ',' ].
	self error: 'end of object expected'! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 6/25/2009 23:35'!
parseProperty
	| name value |
	name := self parseString.
	self expect: ':'.
	value := self parseValue.
	^ self createProperty: name with: value.! !

!JSJsonParser methodsFor: 'parsing-internal' stamp: 'lr 6/29/2009 14:40'!
parseString
	| result |
	self expect: '"'.
	result := WriteStream on: String new.
	[ stream atEnd or: [ stream peek = $" ] ] 
		whileFalse: [ result nextPut: self parseCharacter ].
	^ self expect: '"'; createString: result contents! !

!JSJsonParser methodsFor: 'parsing' stamp: 'lr 6/29/2009 14:39'!
parseValue
	| char |
	stream atEnd ifFalse: [ 
		char := stream peek.
		char = ${
			ifTrue: [ ^ self parseObject ].
		char = $[
			ifTrue: [ ^ self parseArray ].
		char = $"
			ifTrue: [ ^ self parseString ].
		(char = $- or: [ char between: $0 and: $9 ])
			ifTrue: [ ^ self parseNumber ].
		(self match: 'true')
			ifTrue: [ ^ self createTrue ].
		(self match: 'false')
			ifTrue: [ ^ self createFalse ].
		(self match: 'null')
			ifTrue: [ ^ self createNull ] ].
	self error: 'invalid input'! !

!JSJsonParser methodsFor: 'private' stamp: 'lr 6/25/2009 23:01'!
whitespace
	"Strip whitespaces from the input stream."

	[ stream atEnd not and: [ stream peek isSeparator ] ]
		whileTrue: [ stream next ]! !

WAObject subclass: #JSObject
	instanceVariableNames: 'decoration renderContext rendererClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core'!

!JSObject commentStamp: 'lr 12/31/2009 23:50' prior: 0!
I represent the abstract root of all JavaScript objects in the Smalltalk world. My subclasses provide accessors and action methods to configure instances of myself and implement the method #javascriptContentOn: to emit valid JavaScript code for my presentation.

Instance Variables
	decoration:			<JSObject|JSDecoration>
	renderContext:		<WARenderContext>
	rendererClass:		<WARenderer>!

JSObject subclass: #JSJoin
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core'!

!JSJoin commentStamp: 'lr 4/28/2008 09:46' prior: 0!
I join a collection of JavaScript statements with the given string.!

!JSJoin class methodsFor: 'instance creation' stamp: 'lr 10/16/2008 19:19'!
new
	^ self on: OrderedCollection new! !

!JSJoin class methodsFor: 'instance creation' stamp: 'lr 10/16/2008 19:19'!
on: aCollection
	^ self basicNew initializeOn: aCollection! !

!JSJoin methodsFor: 'accessing' stamp: 'avi 9/27/2005 23:40'!
collection
	^ collection! !

!JSJoin methodsFor: 'encoding' stamp: 'lr 7/14/2010 13:24'!
encodeElement: anObject on: aDocument
	"We assume that the element is already URL encoded if this is not an association."

	(anObject isKindOf: Association)
		ifTrue: [
			aDocument nextPut: $".
			aDocument urlEncoder
				nextPutAll: anObject key greaseString.
			anObject value isNil 
				ifTrue: [ aDocument nextPut: $" ]
				ifFalse: [
					aDocument nextPut: $=.
					(anObject value isString or: [ anObject value isCharacter ])
						ifTrue: [
							aDocument urlEncoder 
								nextPutAll: anObject value greaseString.
							aDocument nextPut: $" ]
						ifFalse: [
							aDocument nextPutAll: '"+encodeURIComponent('.
							aDocument stream javascript: anObject value.
							aDocument nextPut: $) ] ] ]
		ifFalse: [ aDocument stream javascript: anObject ]! !

!JSJoin methodsFor: 'encoding' stamp: 'lr 7/14/2010 12:48'!
encodeEmptyOn: aDocument
	aDocument nextPutAll: '""'! !

!JSJoin methodsFor: 'encoding' stamp: 'lr 7/14/2010 12:48'!
encodeOn: aDocument
	self collection isEmpty
		ifTrue: [ ^ self encodeEmptyOn: aDocument ].
	self collection size = 1
		ifTrue: [ ^ self encodeElement: self collection first on: aDocument ].
	aDocument nextPut: $[.
	self collection
		do: [ :each | self encodeElement: each on: aDocument ]
		separatedBy: [ aDocument nextPut: $, ].
	aDocument nextPutAll: '].join("&")'! !

!JSJoin methodsFor: 'initialization' stamp: 'jf 3/13/2009 17:59'!
initializeOn: aCollection
	self initialize.
	collection := aCollection! !

!JSJoin methodsFor: 'printing' stamp: 'lr 7/14/2010 13:11'!
javascriptContentOn: aStream
	| document codec |
	codec := [ self requestContext codec ] 
		on: WARequestContextNotFound
		do: [ :e | GRNullCodec new ].
	document := WAUnescapedDocument 
		on: aStream
		codec: codec.
	self encodeOn: document! !

JSObject subclass: #JSJson
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core'!

!JSJson commentStamp: 'lr 12/31/2009 23:52' prior: 0!
I represent the JSON object (www.json.org) that is supported by most modern web browsers. For older browsers I require JSJsonDeploymentLibrary or JSJsonDevelopmentLibrary to be included.!

!JSJson methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	aStream nextPutAll: 'JSON'! !

!JSJson methodsFor: 'accessing' stamp: 'lr 9/22/2009 10:44'!
parse: aString
	"This method parses a JSON text to produce an object or array."

	self call: 'parse' with: aString! !

!JSJson methodsFor: 'accessing' stamp: 'lr 9/22/2009 10:48'!
parse: aString reviver: aFunction 
	"This method parses a JSON text to produce an object or array. The optional reviver parameter is a function that can filter and transform the results. It receives each of the keys and values, and its return value is used instead of the original value. If it returns what it received, then the structure is not modified. If it returns undefined then the member is deleted."

	self call: 'parse' with: aString with: aFunction asFunction! !

!JSJson methodsFor: 'accessing' stamp: 'lr 9/22/2009 10:39'!
stringify: anObject
	"Serialize anObject as a JSON string."

	self call: 'stringify' with: anObject! !

!JSJson methodsFor: 'accessing' stamp: 'lr 9/22/2009 10:42'!
stringify: anObject replacer: aReplacer
	"Serialize anObject as a JSON string. aReplacer is an optional parameter that determines how object values are stringified for objects. It can be a function or an array of strings."

	self call: 'stringify' with: anObject with: aReplacer! !

!JSJson methodsFor: 'accessing' stamp: 'lr 9/22/2009 10:42'!
stringify: anObject replacer: aReplacer space: aSpace
	"Serialize anObject as a JSON string. aReplacer is an optional parameter that determines how object values are stringified for objects. It can be a function or an array of strings. aSpace is an optional parameter that specifies the indentation of nested structures. If it is omitted, the text will be packed without extra whitespace."

	self call: 'stringify' with: anObject with: aReplacer with: aSpace! !

!JSJson methodsFor: 'accessing' stamp: 'lr 9/22/2009 10:42'!
stringify: anObject space: aSpace
	"Serialize anObject as a JSON string. aSpace is an optional parameter that specifies the indentation of nested structures. If it is omitted, the text will be packed without extra whitespace."

	self call: 'stringify' with: anObject with: aSpace! !

JSObject subclass: #JSLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core'!

!JSLogger commentStamp: 'lr 11/28/2006 10:40' prior: 0!
I am a logger class to be used together with FireBug. I have nothing to do with Scriptaculous directly, but I nicely fit in here as everybody should be using FireBug for Script debugging anyway.!

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assert: anObject 
	self 
		call: 'assert'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:13'!
assert: anObject equals: anotherObject 
	self 
		call: 'assertEquals'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:11'!
assert: anObject greater: anotherObject 
	self 
		call: 'assertGreater'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:11'!
assert: anObject less: anotherObject 
	self 
		call: 'assertLess'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:12'!
assert: anObject notEquals: anotherObject 
	self 
		call: 'assertNotEquals'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:13'!
assert: anObject notGreater: anotherObject 
	self 
		call: 'assertNotGreater'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:13'!
assert: anObject notLess: anotherObject 
	self 
		call: 'assertNotLess'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertFalse: anObject 
	self 
		call: 'assertFalse'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertNotNull: anObject 
	self 
		call: 'assertNotNull'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertNotUndefined: anObject 
	self 
		call: 'assertNotUndefined'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertNull: anObject 
	self 
		call: 'assertNull'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertTrue: anObject 
	self 
		call: 'assertTrue'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertUndefined: anObject 
	self 
		call: 'assertUndefined'
		with: anObject! !

!JSLogger methodsFor: 'messages' stamp: 'lr 10/14/2008 09:10'!
debug: anObject 
	self 
		call: 'debug'
		with: anObject! !

!JSLogger methodsFor: 'messages' stamp: 'lr 10/14/2008 09:10'!
error: anObject 
	self 
		call: 'error'
		with: anObject! !

!JSLogger methodsFor: 'messages' stamp: 'lr 10/14/2008 09:10'!
info: anObject 
	self 
		call: 'info'
		with: anObject! !

!JSLogger methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	aStream nextPutAll: 'console'! !

!JSLogger methodsFor: 'logging' stamp: 'lr 10/14/2008 09:10'!
log: anObject 
	self 
		call: 'log'
		with: anObject! !

!JSLogger methodsFor: 'logging' stamp: 'lr 10/14/2008 09:10'!
log: anObject format: anArray 
	self 
		call: 'log'
		withArguments: (Array with: anObject) , anArray! !

!JSLogger methodsFor: 'messages' stamp: 'lr 10/14/2008 09:10'!
warn: anObject 
	self 
		call: 'warn'
		with: anObject! !

!JSObject class methodsFor: 'instance creation' stamp: 'jf 7/19/2009 14:07'!
context: aRenderContext
	^ self new setContext: aRenderContext; yourself! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:44'!
& anObject 
	"Combine the receiver and anObject with a logical AND."
	
	self addDecoration: (JSBinary new operator: '&&'; statement: anObject)! !

!JSObject methodsFor: 'convenience' stamp: 'lr 12/31/2009 23:44'!
, anObject 
	"Concatenate the receiver with anObject."

	self addDecoration: (JSConcatenation on: anObject)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:42'!
access: aString 
	"Access the member aString."
	
	self addDecoration: (JSAccess named: aString)! !

!JSObject methodsFor: 'adding' stamp: 'lr 11/17/2008 20:15'!
addDecoration: aDecoration
	"Add a new decoration to the receiver."

	aDecoration setOwner: decoration.
	decoration := aDecoration! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:42'!
alias: aString 
	"Uses aString as an alias for the receiver."
	
	self addDecoration: (JSAlias named: aString)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:40'!
apply: aCollection 
	"Apply aCollection of arguments."
	
	self addDecoration: (JSApply new arguments: aCollection)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:40'!
assign: anObject 
	"Assign anObject to the receiver."
	
	self addDecoration: (JSAssignment new object: anObject)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:43'!
assignLocalTo: aString 
	"Assign the receiver to a local variable aString."
	
	self addDecoration: (JSAssignLocal named: aString)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:43'!
assignTo: aString 
	"Assign the receiver to a global variable aString."
	
	self addDecoration: (JSAssign named: aString)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 4/24/2009 20:22'!
call: aString
	"Call the method named aString."

	self call: aString withArguments: #()! !

!JSObject methodsFor: 'deprecated' stamp: 'lr 12/31/2009 23:45'!
call: aString argument: anObject 
	"Call the method named aString with anObject as its argument."
	
	self greaseDeprecatedApi: 'JSObject>>#call:argument:' details: 'Use #call:with:.'.
	self call: aString with: anObject! !

!JSObject methodsFor: 'deprecated' stamp: 'lr 12/31/2009 23:45'!
call: aString arguments: anArray 
	"Call the method named aString with aCollection as its arguments."

	self greaseDeprecatedApi: 'JSObject>>#call:arguments:' details: 'Use #call:withArguments:.'.
	self call: aString withArguments: anArray! !

!JSObject methodsFor: 'decorations' stamp: 'lr 4/24/2009 20:22'!
call: aString with: anObject
	"Call the method named aString with anObject as its argument."

	self call: aString withArguments: (Array with: anObject)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 4/24/2009 20:22'!
call: aString with: anObject1 with: anObject2
	"Call the method named aString with anObject1 and anObject2 as its arguments."

	self call: aString withArguments: (Array with: anObject1 with: anObject2)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 4/24/2009 20:22'!
call: aString with: anObject1 with: anObject2 with: anObject3
	"Call the method named aString with anObject1 and anObject2 and anObject3 as its arguments."

	self call: aString withArguments: (Array with: anObject1 with: anObject2 with: anObject3)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 4/24/2009 20:22'!
call: aString withArguments: anArray
	"Call the method named aString with anArray as arguments."

	self addDecoration: (JSCall new 
		name: aString;
		arguments: anArray;
		yourself)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:41'!
condition: anObject 
	"Treat anObject as a condition to the execution of the receiver."
	
	self addDecoration: (JSCondition on: anObject)! !

!JSObject methodsFor: 'convenience' stamp: 'lr 10/14/2008 12:19'!
confirm: anObject 
	"Show a confirmation with the message anObject before evaluating the receiver."
	
	self condition: (JSStream new
		nextPutAll: 'confirm';
		argument: anObject)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:41'!
create
	"Instantiate the receiver."
	
	self addDecoration: JSCreate new! !

!JSObject methodsFor: 'accessing' stamp: 'lr 10/13/2008 21:14'!
decoration
	"Answer the top-level decoration in the receivers decoration stack."

	^ decoration! !

!JSObject methodsFor: 'printing' stamp: 'lr 12/24/2009 10:34'!
greaseString
	^ String streamContents: [ :stream | stream javascript: self ]! !

!JSObject methodsFor: 'initialization' stamp: 'lr 11/11/2008 22:57'!
initialize
	super initialize.
	decoration := self! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:44'!
interval: aDuration
	"Execute the receiver every aDuration."

	self addDecoration: (JSInterval duration: aDuration)! !

!JSObject methodsFor: 'testing' stamp: 'lr 12/4/2008 22:30'!
isJavascript
	^ true! !

!JSObject methodsFor: 'printing' stamp: 'lr 12/31/2009 23:48'!
javascriptContentOn: aStream
	"Generate the JavaScript string of the receiver. Override this method in subclasses to define custom JavaScript code. Note, if you run into this method, you likely use old Seaside code need to rename #printContentOn: to #javascriptContentOn:."
	
	self subclassResponsibility! !

!JSObject methodsFor: 'printing' stamp: 'lr 12/31/2009 23:48'!
javascriptOn: aStream
	"Generate the JavaScript code from the receiver by dispatching to the outermost surrounding decoration. Do not override this method, instead override #javascriptContentOn:."

	self decoration javascriptContentOn: aStream! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:41'!
not
	"Negate the receiver logically."
	
	self addDecoration: JSNegation new! !

!JSObject methodsFor: 'printing' stamp: 'lr 12/24/2009 10:35'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' ('; javascript: self; nextPut: $)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:43'!
property: aString 
	"Treat anObject as a condition to the execution of the receiver."
	
	self addDecoration: (JSProperty named: aString)! !

!JSObject methodsFor: 'utilities' stamp: 'lr 10/14/2008 21:48'!
render: aRenderable
	"Render aRenderable and answer the resulting string."
	
	^ String streamContents: [ :stream | self render: aRenderable on: stream ]! !

!JSObject methodsFor: 'utilities' stamp: 'lr 2/22/2010 22:28'!
render: aRenderable on: aStream
	"Render aRenderable on aStream."
	
	| document |
	document := WAHtmlDocument
		on: aStream
		codec: self requestContext codec.
	self renderContext document: document during: [
		(self rendererClass context: self renderContext)
			render: aRenderable; flush ].
	document scriptGenerator closeOn: document! !

!JSObject methodsFor: 'accessing' stamp: 'jf 7/19/2009 13:57'!
renderContext
	"Answer the current RenderContext."

	^ renderContext! !

!JSObject methodsFor: 'accessing' stamp: 'jf 7/19/2009 18:23'!
rendererClass
	"Answer the class that should be used when rendering objects."

	^ rendererClass ifNil: [ rendererClass := WARenderer default ]! !

!JSObject methodsFor: 'accessing' stamp: 'jf 7/19/2009 17:21'!
rendererClass: aRendererClass
	"Specify the class that should be used when rendering objects."

	rendererClass := aRendererClass! !

!JSObject methodsFor: 'convenience' stamp: 'lr 10/14/2008 12:22'!
return: anObject 
	"Return anObject after evaluating the receiver."
	
	self , (JSStream new
		nextPutAll: 'return ';
		javascript: anObject)! !

!JSObject methodsFor: 'utilities' stamp: 'lr 10/14/2008 21:48'!
script: aBlock
	"Evaluate aBlock and answer the string of the generated script."
	
	^ String streamContents: [ :stream | self script: aBlock on: stream ]! !

!JSObject methodsFor: 'utilities' stamp: 'lr 2/22/2010 22:12'!
script: aBlock on: aStream
	"Evaluate aBlock and pass in a script object that is subsequently written to aStream."

	| script document |
	document := WAHtmlDocument
		on: aStream
		codec: self requestContext codec.
	self renderContext document: document during: [ 
		script := (JSScript context: self renderContext)
			rendererClass: self rendererClass;
			yourself.
		aBlock value: script.
		script addAll: document loadScripts ].
	script javascriptOn: aStream! !

!JSObject methodsFor: 'initialization' stamp: 'jf 7/19/2009 14:06'!
setContext: aRenderContext
	renderContext := aRenderContext! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:16'!
then: anObject
	"Evaluates anObject if the receiver treated as a boolean evaluates to true."

	self then: anObject else: nil! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:41'!
then: anObject else: anotherObject 
	"Evaluates anObject if the receiver treated as a boolean evaluates to true, otherwise evaluate anotherObject."
	
	self addDecoration: (JSIfThenElse new
		trueStatement: anObject;
		falseStatement: anotherObject)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:44'!
timeout: aDuration 
	"Evaluates the receiver after aDuration."
	
	self addDecoration: (JSTimeout duration: aDuration)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:44'!
| anObject 
	"Combine the receiver and anObject with a logical OR."
	
	self addDecoration: (JSBinary new operator: '||'; statement: anObject)! !

JSObject subclass: #JSScript
	instanceVariableNames: 'statements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core'!

!JSScript commentStamp: 'lr 4/28/2008 09:41' prior: 0!
I represent a sequence of JavaScript statements.!

JSScript subclass: #JSFunction
	instanceVariableNames: 'return arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core'!

!JSFunction commentStamp: 'lr 4/28/2008 09:40' prior: 0!
I represent an anonymous JavaScript function.!

!JSFunction methodsFor: 'accessing' stamp: 'lr 1/4/2007 15:57'!
argument
	^ arguments! !

!JSFunction methodsFor: 'accessing' stamp: 'lr 1/4/2007 15:55'!
arguments
	^ arguments! !

!JSFunction methodsFor: 'accessing' stamp: 'lr 1/4/2007 15:55'!
arguments: aCollection
	arguments := aCollection! !

!JSFunction methodsFor: 'converting' stamp: 'lr 5/17/2006 11:27'!
asFunction
	^ self! !

!JSFunction methodsFor: 'converting' stamp: 'lr 1/4/2007 17:22'!
asFunction: aCollection
	self arguments: aCollection! !

!JSFunction methodsFor: 'initialization' stamp: 'lr 1/4/2007 15:59'!
initialize
	super initialize.
	arguments := #()! !

!JSFunction methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	aStream nextPutAll: 'function('.
	self arguments do: [ :each | aStream nextPutAll: each ] separatedBy: [ aStream nextPut: $, ].
	aStream nextPutAll: '){'.
	statements isEmpty ifFalse:
			[ statements allButLast do:
					[ :each | 
					aStream
						javascript: each;
						nextPut: $; ].
			self return ifTrue: [ aStream nextPutAll: 'return ' ].
			aStream javascript: statements last ].
	aStream nextPut: $}! !

!JSFunction methodsFor: 'accessing' stamp: 'lr 5/15/2006 11:04'!
return
	^ return ifNil: [ false ]! !

!JSFunction methodsFor: 'accessing' stamp: 'lr 5/15/2006 11:04'!
return: aBoolean
	return := aBoolean! !

!JSScript methodsFor: 'adding' stamp: 'lr 8/29/2006 08:36'!
, anObject
	self add: anObject! !

!JSScript methodsFor: 'adding' stamp: 'lr 10/19/2008 19:10'!
<< anObject
	^ self add: anObject! !

!JSScript methodsFor: 'adding' stamp: 'lr 8/4/2006 08:59'!
add: anObject
	^ statements add: anObject! !

!JSScript methodsFor: 'adding' stamp: 'lr 12/3/2008 19:11'!
addAll: aCollection
	^ statements addAll: aCollection! !

!JSScript methodsFor: 'convenience' stamp: 'lr 10/13/2008 21:34'!
alert: anObject 
	self add: (JSStream new
		nextPutAll: 'alert';
		argument: anObject;
		yourself)! !

!JSScript methodsFor: 'convenience' stamp: 'jf 2/15/2010 02:11'!
callback: aBlock
	self goto: (self renderContext actionUrl
		withField: (self renderContext callbacks store: (WAActionCallback on: aBlock)))! !

!JSScript methodsFor: 'convenience' stamp: 'lr 9/8/2009 12:50'!
goto: aUrl 
	self add: (JSStream new
		nextPutAll: 'window.location=';
		javascript: aUrl)! !

!JSScript methodsFor: 'initialization' stamp: 'lr 5/10/2006 19:47'!
initialize
	super initialize.
	statements := OrderedCollection new! !

!JSScript methodsFor: 'convenience' stamp: 'lr 10/28/2009 20:57'!
javascript
	^ (JSScript context: self renderContext)
		rendererClass: self rendererClass;
		yourself! !

!JSScript methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	statements do: [ :each | aStream javascript: each ] separatedBy: [ aStream nextPut: $; ]! !

!JSScript methodsFor: 'convenience' stamp: 'lr 9/22/2009 10:52'!
logger
	^ self add: ((JSLogger context: self renderContext)
		rendererClass: self rendererClass;
		yourself)! !

!JSScript methodsFor: 'convenience' stamp: 'jf 7/19/2009 13:57'!
refresh
	self goto: self renderContext actionUrl! !

JSObject subclass: #JSStream
	instanceVariableNames: 'stream'
	classVariableNames: 'Arguments JavascriptCharacters This'
	poolDictionaries: ''
	category: 'Javascript-Core'!

!JSStream commentStamp: 'lr 4/28/2008 09:44' prior: 0!
I represent a verbatim JavaScript string. I support streaming facilities to efficiently encode JavaScript input.!

!JSStream class methodsFor: 'instance creation' stamp: 'lr 10/16/2008 21:49'!
argument: anInteger
	^ (Arguments at: anInteger + 1) copy! !

!JSStream class methodsFor: 'instance creation' stamp: 'lr 10/16/2008 21:49'!
argumentAt: anInteger
	^ (Arguments at: anInteger) copy! !

!JSStream class methodsFor: 'encoding' stamp: 'lr 2/12/2009 09:43'!
encodeArguments: aCollection on: aStream 
	"Writes aCollection of elements to aStream enclosed in round brakes and separated by a comma."
	
	aStream nextPut: $(.
	aCollection
		do: [ :each | aStream javascript: each ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $)! !

!JSStream class methodsFor: 'encoding' stamp: 'lr 2/12/2009 09:43'!
encodeCollection: aCollection on: aStream
	"Writes aCollection of elements to aStream enclosed in square brakets."
	
	aStream nextPut: $[.
	aCollection
		do: [ :each | aStream javascript: each ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $]! !

!JSStream class methodsFor: 'encoding' stamp: 'lr 2/12/2009 09:44'!
encodeDictionary: aDictionary on: aStream 
	"Dictionary or hash-maps common structures in JavaScript, try to optimize their serialization."
	
	| first |
	first := true.
	aStream nextPut: ${.
	aDictionary keysAndValuesDo: [ :key :value |
		first
			ifTrue: [ first := false ]
			ifFalse: [ aStream nextPut: $, ].
		self encodeKey: key value: value on: aStream ].
	aStream nextPut: $}! !

!JSStream class methodsFor: 'encoding' stamp: 'lr 4/15/2010 20:21'!
encodeKey: aKey value: aValue on: aStream 
	"Key-value pairs are common structures in JavaScript."
	
	aStream javascript: aKey greaseString; nextPut: $:; javascript: aValue! !

!JSStream class methodsFor: 'encoding' stamp: 'lr 3/4/2010 22:45'!
encodeString: aString on: aStream 
	"Strings have a complicated encoding in Javascript, try to optimize their serialization."
	
	| char value encoded last |
	aStream nextPut: $".
	1 to: aString size do: [ :index | 
		char := aString at: index.
		value := char greaseInteger.
		value < JavascriptCharacters size 
			ifFalse: [ aStream nextPut: char ]
			ifTrue: [
				encoded := JavascriptCharacters at: value + 1.
				encoded isString 
					ifTrue: [ aStream nextPutAll: encoded ]
					ifFalse: [
						"avoid that browsers mistakenly take the output as a closing tag"
						(last = $< and: [ char = $/ ])
							ifTrue: [ aStream nextPutAll: '\/' ]
							ifFalse: [ aStream nextPut: encoded ] ] ].
		last := char ].
	aStream nextPut: $"! !

!JSStream class methodsFor: 'initialization' stamp: 'lr 10/14/2008 11:36'!
initialize
	self initializeEncoding.
	self initializeSnippets! !

!JSStream class methodsFor: 'initialization' stamp: 'dkh 12/8/2009 14:43'!
initializeEncoding
	| printer escapes |
	printer := GRNumberPrinter new.
	printer base: 16; padding: $0; digits: 2.
	JavascriptCharacters := Array new: 127.
	0 to: 31 do: [ :index | 
		JavascriptCharacters 
			at: index + 1
			put: '\x' , (printer print: index) ].
	32 to: 126 do: [ :index | 
		JavascriptCharacters 
			at: index + 1
			put: index asCharacter ].
	escapes := #( 0 '\0' 7 '\a' 8 '\b' 9 '\t' 10 '\n' 12 '\f' 13 '\r' 34 '\"' 92 '\\' ).
	1 to: escapes size - 1 by: 2 do: [ :index | 
		JavascriptCharacters 
			at: (escapes at: index) + 1
			put: (escapes at: index + 1) ]! !

!JSStream class methodsFor: 'initialization' stamp: 'lr 10/14/2008 11:36'!
initializeSnippets
	This := self on: 'this'.
	Arguments := (0 to: 25)
		collect: [ :each | self on: 'arguments[' , each printString , ']' ]! !

!JSStream class methodsFor: 'instance creation' stamp: 'lr 5/10/2006 20:36'!
on: aString
	^ self new nextPutAll: aString! !

!JSStream class methodsFor: 'instance creation' stamp: 'lr 10/14/2008 11:45'!
this
	^ This copy! !

!JSStream methodsFor: 'convenience' stamp: 'lr 2/12/2009 09:56'!
argument: anObject
	"Write a single argument anObject onto the receiving stream."

	self arguments: (Array with: anObject)! !

!JSStream methodsFor: 'convenience' stamp: 'lr 2/12/2009 09:57'!
arguments: aCollection
	"Write aCollection of arguments onto the stream."

	self class encodeArguments: aCollection on: self! !

!JSStream methodsFor: 'accessing' stamp: 'lr 5/1/2006 17:06'!
contents
	^ self stream contents! !

!JSStream methodsFor: 'copying' stamp: 'lr 5/10/2006 20:36'!
copy
	^ self class on: self contents! !

!JSStream methodsFor: 'initialization' stamp: 'lr 2/4/2009 08:02'!
initialize
	super initialize.
	stream := WriteStream on: String new! !

!JSStream methodsFor: 'streaming' stamp: 'lr 5/1/2006 17:07'!
javascript: anObject
	self stream javascript: anObject! !

!JSStream methodsFor: 'printing' stamp: 'lr 12/24/2009 10:16'!
javascriptContentOn: aStream
	aStream nextPutAll: self contents! !

!JSStream methodsFor: 'streaming' stamp: 'lr 2/2/2010 21:24'!
json: anObject
	self stream json: anObject! !

!JSStream methodsFor: 'streaming' stamp: 'lr 5/1/2006 17:07'!
nextPut: aCharacter
	self stream nextPut: aCharacter! !

!JSStream methodsFor: 'streaming' stamp: 'lr 5/1/2006 17:07'!
nextPutAll: aString
	self stream nextPutAll: aString! !

!JSStream methodsFor: 'accessing' stamp: 'lr 5/1/2006 17:06'!
stream
	^ stream! !

!Boolean methodsFor: '*javascript-core' stamp: 'DaleHenrichs 6/4/2010 12:27'!
jsonOn: aStream
	self javascriptOn: aStream! !

!Stream methodsFor: '*javascript-core' stamp: 'lr 4/11/2006 19:45'!
javascript: anObject
	anObject javascriptOn: self! !

!Stream methodsFor: '*javascript-core' stamp: 'BartGauquie 2/1/2010 21:12'!
json: anObject
	anObject jsonOn: self! !

GRObject subclass: #JSJsonStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-JSON'!

!JSJsonStream commentStamp: 'pmm 8/30/2009 18:59' prior: 0!
I am a specialization of JSStream that conforms to the JSON spec (http://www.json.org).!

!JSJsonStream class methodsFor: 'encoding' stamp: 'lr 2/2/2010 22:28'!
encodeCollection: aCollection on: aStream
	"Writes aCollection of elements to aStream enclosed in square brakets."
	
	aStream nextPut: $[.
	aCollection
		do: [ :each | aStream json: each ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $]! !

!JSJsonStream class methodsFor: 'encoding' stamp: 'lr 2/2/2010 22:29'!
encodeDictionary: aDictionary on: aStream 
	"Dictionary or hash-maps common structures in JSON to aStream."
	
	| first |
	first := true.
	aStream nextPut: ${.
	aDictionary keysAndValuesDo: [ :key :value |
		first
			ifTrue: [ first := false ]
			ifFalse: [ aStream nextPut: $, ].
		aStream 
			json: key greaseString;
			nextPut: $:;
			json: value ].
	aStream nextPut: $}! !

WACallback subclass: #JSAjaxCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core'!

!JSAjaxCallback methodsFor: 'accessing' stamp: 'lr 12/6/2008 20:54'!
block: aZeroOrOneArgBlock
	block := aZeroOrOneArgBlock isNil
		ifFalse: [ aZeroOrOneArgBlock fixCallbackTemps ]! !

!JSAjaxCallback methodsFor: 'evaluation' stamp: 'lr 5/20/2009 19:58'!
evaluateWithArgument: anObject
	block isNil
		ifFalse: [ block valueWithPossibleArguments: (Array with: anObject) ].
	self requestContext
		respond: [ :response | response doNotCache ]! !

!JSAjaxCallback methodsFor: 'accessing' stamp: 'lr 12/28/2008 14:49'!
priority
	^ 5! !

WACallback subclass: #JSPassenger
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core'!

!JSPassenger methodsFor: 'evaluation' stamp: 'lr 10/21/2008 16:07'!
evaluateWithArgument: anObject
	self shouldNotImplement! !

!JSPassenger methodsFor: 'testing' stamp: 'lr 2/15/2009 16:56'!
isEnabledFor: aRequestContext
	^ false! !

!JSPassenger methodsFor: 'testing' stamp: 'lr 10/21/2008 16:15'!
isPassenger
	^ true! !

!JSPassenger methodsFor: 'accessing' stamp: 'lr 10/21/2008 16:08'!
object
	^ object! !

!JSPassenger methodsFor: 'initialization' stamp: 'lr 10/21/2008 16:09'!
setObject: anObject
	object := anObject! !

!WACallback methodsFor: '*javascript-core' stamp: 'lr 10/21/2008 16:16'!
isPassenger
	^ false! !
JSStream initialize!
